added ikev1/net2net-same-nets scenario
[strongswan.git] / testing / tests / ikev1 / net2net-same-nets / hosts / sun / etc / mark_updown
1 #! /bin/sh
2 # updown script setting inbound marks on ESP traffic in the mangle chain
3 #
4 # Copyright (C) 2003-2004 Nigel Meteringham
5 # Copyright (C) 2003-2004 Tuomo Soini
6 # Copyright (C) 2002-2004 Michael Richardson
7 # Copyright (C) 2005-2010 Andreas Steffen <andreas.steffen@strongswan.org>
8 #
9 # This program is free software; you can redistribute it and/or modify it
10 # under the terms of the GNU General Public License as published by the
11 # Free Software Foundation; either version 2 of the License, or (at your
12 # option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
13 #
14 # This program is distributed in the hope that it will be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
16 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
17 # for more details.
18
19 # CAUTION:  Installing a new version of strongSwan will install a new
20 # copy of this script, wiping out any custom changes you make.  If
21 # you need changes, make a copy of this under another name, and customize
22 # that, and use the (left/right)updown parameters in ipsec.conf to make
23 # strongSwan use yours instead of this default one.
24
25 # things that this script gets (from ipsec_pluto(8) man page)
26 #
27 #      PLUTO_VERSION
28 #              indicates  what  version of this interface is being
29 #              used.  This document describes version  1.1.   This
30 #              is upwardly compatible with version 1.0.
31 #
32 #       PLUTO_VERB
33 #              specifies the name of the operation to be performed
34 #              (prepare-host, prepare-client, up-host, up-client,
35 #              down-host, or down-client).  If the address family
36 #              for security gateway to security gateway communica-
37 #              tions is IPv6, then a suffix of -v6 is added to the
38 #              verb.
39 #
40 #       PLUTO_CONNECTION
41 #              is the name of the  connection  for  which  we  are
42 #              routing.
43 #
44 #       PLUTO_NEXT_HOP
45 #              is the next hop to which packets bound for the peer
46 #              must be sent.
47 #
48 #       PLUTO_INTERFACE
49 #              is the name of the ipsec interface to be used.
50 #
51 #       PLUTO_REQID
52 #              is the requid of the ESP policy
53 #
54 #       PLUTO_ME
55 #              is the IP address of our host.
56 #
57 #       PLUTO_MY_ID
58 #              is the ID of our host.
59 #
60 #       PLUTO_MY_CLIENT
61 #              is the IP address / count of our client subnet.  If
62 #              the  client  is  just  the  host,  this will be the
63 #              host's own IP address / max (where max  is  32  for
64 #              IPv4 and 128 for IPv6).
65 #
66 #       PLUTO_MY_CLIENT_NET
67 #              is the IP address of our client net.  If the client
68 #              is just the host, this will be the  host's  own  IP
69 #              address.
70 #
71 #       PLUTO_MY_CLIENT_MASK
72 #              is  the  mask for our client net.  If the client is
73 #              just the host, this will be 255.255.255.255.
74 #
75 #       PLUTO_MY_SOURCEIP
76 #              if non-empty, then the source address for the route will be
77 #              set to this IP address.
78 #
79 #       PLUTO_MY_PROTOCOL
80 #              is the IP protocol that will be transported.
81 #
82 #       PLUTO_MY_PORT
83 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
84 #              restricted on our side.
85 #
86 #       PLUTO_PEER
87 #              is the IP address of our peer.
88 #
89 #       PLUTO_PEER_ID
90 #              is the ID of our peer.
91 #
92 #       PLUTO_PEER_CA
93 #              is the CA which issued the cert of our peer.
94 #
95 #       PLUTO_PEER_CLIENT
96 #              is the IP address / count of the peer's client sub-
97 #              net.   If the client is just the peer, this will be
98 #              the peer's own IP address / max (where  max  is  32
99 #              for IPv4 and 128 for IPv6).
100 #
101 #       PLUTO_PEER_CLIENT_NET
102 #              is the IP address of the peer's client net.  If the
103 #              client is just the peer, this will  be  the  peer's
104 #              own IP address.
105 #
106 #       PLUTO_PEER_CLIENT_MASK
107 #              is  the  mask  for  the  peer's client net.  If the
108 #              client   is   just   the   peer,   this   will   be
109 #              255.255.255.255.
110 #
111 #       PLUTO_PEER_PROTOCOL
112 #              is the IP protocol that will be transported.
113 #
114 #       PLUTO_PEER_PORT
115 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
116 #              restricted on the peer side.
117 #
118 #       PLUTO_XAUTH_ID
119 #              is an optional user ID employed by the XAUTH protocol
120 #
121 #       PLUTO_MARK_IN
122 #              is an optional XFRM mark set on the inbound IPsec SA
123 #
124 #       PLUTO_MARK_OUT
125 #              is an optional XFRM mark set on the outbound IPsec SA
126 #
127 #       PLUTO_UDP_ENC
128 #              contains the remote UDP port in the case of ESP_IN_UDP
129 #              encapsulation
130 #
131
132 # define a minimum PATH environment in case it is not set
133 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/sbin"
134 export PATH
135
136 # check parameter(s)
137 case "$1:$*" in
138 ':')                    # no parameters
139         ;;
140 iptables:iptables)      # due to (left/right)firewall; for default script only
141         ;;
142 custom:*)               # custom parameters (see above CAUTION comment)
143         ;;
144 *)      echo "$0: unknown parameters \`$*'" >&2
145         exit 2
146         ;;
147 esac
148
149 # utility functions for route manipulation
150 # Meddling with this stuff should not be necessary and requires great care.
151 uproute() {
152         doroute add
153         ip route flush cache
154 }
155 downroute() {
156         doroute delete
157         ip route flush cache
158 }
159
160 addsource() {
161         st=0
162         if ! ip -o route get ${PLUTO_MY_SOURCEIP%/*} | grep -q ^local
163         then
164             it="ip addr add ${PLUTO_MY_SOURCEIP%/*}/32 dev $PLUTO_INTERFACE"
165             oops="`eval $it 2>&1`"
166             st=$?
167             if test " $oops" = " " -a " $st" != " 0"
168             then
169                 oops="silent error, exit status $st"
170             fi
171             if test " $oops" != " " -o " $st" != " 0"
172             then
173                 echo "$0: addsource \`$it' failed ($oops)" >&2
174             fi
175         fi
176         return $st
177 }
178
179 doroute() {
180         st=0
181
182         if [ -z "$PLUTO_MY_SOURCEIP" ]
183         then
184             for dir in /etc/sysconfig /etc/conf.d; do
185                 if [ -f "$dir/defaultsource" ]
186                 then
187                     . "$dir/defaultsource"
188                 fi
189             done
190
191             if [ -n "$DEFAULTSOURCE" ]
192             then
193                 PLUTO_MY_SOURCEIP=$DEFAULTSOURCE
194             fi
195         fi
196
197         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
198         then
199             # leave because no route entry is required
200             return $st
201         fi
202
203         parms1="$PLUTO_PEER_CLIENT"
204
205         if [ -n "$PLUTO_NEXT_HOP" ]
206         then
207             parms2="via $PLUTO_NEXT_HOP"
208         else
209             parms2="via $PLUTO_PEER"
210         fi
211         parms2="$parms2 dev $PLUTO_INTERFACE"
212
213         parms3=
214         if [ -n "$PLUTO_MY_SOURCEIP" ]
215         then
216             if test "$1" = "add"
217             then
218                 addsource
219                 if ! ip rule list | grep -q "lookup $SOURCEIP_ROUTING_TABLE"
220                 then
221                     ip rule add pref $SOURCEIP_ROUTING_TABLE_PRIO table $SOURCEIP_ROUTING_TABLE
222                 fi
223             fi
224             parms3="$parms3 src ${PLUTO_MY_SOURCEIP%/*} table $SOURCEIP_ROUTING_TABLE"
225         fi
226
227         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
228         "0.0.0.0/0.0.0.0")
229                 # opportunistic encryption work around
230                 # need to provide route that eclipses default, without
231                 # replacing it.
232                 it="ip route $1 0.0.0.0/1 $parms2 $parms3 &&
233                         ip route $1 128.0.0.0/1 $parms2 $parms3"
234                 ;;
235         *)      it="ip route $1 $parms1 $parms2 $parms3"
236                 ;;
237         esac
238         oops="`eval $it 2>&1`"
239         st=$?
240         if test " $oops" = " " -a " $st" != " 0"
241         then
242             oops="silent error, exit status $st"
243         fi
244         if test " $oops" != " " -o " $st" != " 0"
245         then
246             echo "$0: doroute \`$it' failed ($oops)" >&2
247         fi
248         return $st
249 }
250 # define NETMAP
251 SAME_NET=$PLUTO_PEER_CLIENT
252 IN_NET=$PLUTO_MY_CLIENT
253 OUT_NET="10.8.0.0/14"
254
255 # define internal interface
256 INT_INTERFACE="eth1"
257
258 # is there an inbound mark to be set?
259 if [ -n "$PLUTO_MARK_IN" ]
260 then
261         if [ -n "$PLUTO_UDP_ENC" ]
262         then
263             SET_MARK_IN="-p udp --sport $PLUTO_UDP_ENC"
264         else
265                 SET_MARK_IN="-p esp"
266         fi
267         SET_MARK_IN="$SET_MARK_IN -s $PLUTO_PEER -j MARK --set-mark $PLUTO_MARK_IN"
268 fi
269
270 # is there an outbound mark to be set?
271 if [ -n "$PLUTO_MARK_OUT" ]
272 then
273         SET_MARK_OUT="-i $INT_INTERFACE -s $SAME_NET -d $OUT_NET -j MARK --set-mark $PLUTO_MARK_OUT"
274 fi
275
276 # resolve octal escape sequences
277 PLUTO_MY_ID=`printf "$PLUTO_MY_ID"`
278 PLUTO_PEER_ID=`printf "$PLUTO_PEER_ID"`
279
280 # the big choice
281 case "$PLUTO_VERB:$1" in
282 prepare-host:*|prepare-client:*)
283         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
284         then
285             # exit because no route will be added,
286             # so that existing routes can stay
287             exit 0
288         fi
289
290         # delete possibly-existing route (preliminary to adding a route)
291         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
292         "0.0.0.0/0.0.0.0")
293                 # need to provide route that eclipses default, without
294                 # replacing it.
295                 parms1="0.0.0.0/1"
296                 parms2="128.0.0.0/1"
297                 it="ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1"
298                 oops="`ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1`"
299                 ;;
300         *)
301                 parms="$PLUTO_PEER_CLIENT"
302                 it="ip route delete $parms 2>&1"
303                 oops="`ip route delete $parms 2>&1`"
304                 ;;
305         esac
306         status="$?"
307         if test " $oops" = " " -a " $status" != " 0"
308         then
309                 oops="silent error, exit status $status"
310         fi
311         case "$oops" in
312         *'RTNETLINK answers: No such process'*)
313                 # This is what route (currently -- not documented!) gives
314                 # for "could not find such a route".
315                 oops=
316                 status=0
317                 ;;
318         esac
319         if test " $oops" != " " -o " $status" != " 0"
320         then
321                 echo "$0: \`$it' failed ($oops)" >&2
322         fi
323         exit $status
324         ;;
325 route-host:*|route-client:*)
326         # connection to me or my client subnet being routed
327         uproute
328         ;;
329 unroute-host:*|unroute-client:*)
330         # connection to me or my client subnet being unrouted
331         downroute
332         ;;
333 up-client:)
334         # connection to my client subnet coming up
335         # If you are doing a custom version, firewall commands go here.
336         if [ -n "$PLUTO_MARK_IN" ]
337         then
338             iptables -t mangle -A PREROUTING $SET_MARK_IN
339             iptables -t nat -A PREROUTING -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN \
340                      -d $IN_NET -j NETMAP --to $SAME_NET 
341             iptables -I FORWARD 1 -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN -j ACCEPT
342             iptables -t nat -A POSTROUTING -o $INT_INTERFACE -m mark --mark $PLUTO_MARK_IN \
343                      -s $SAME_NET -j NETMAP --to $OUT_NET 
344         fi
345         if [ -n "$PLUTO_MARK_OUT" ]
346         then
347             iptables -t mangle -A PREROUTING $SET_MARK_OUT 
348             iptables -t nat -A PREROUTING -i $INT_INTERFACE -m mark --mark $PLUTO_MARK_OUT \
349                      -d $OUT_NET -j NETMAP --to $SAME_NET
350             iptables -I FORWARD 1 -o $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_OUT -j ACCEPT
351             iptables -t nat -A POSTROUTING -o $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_OUT \
352                      -s $SAME_NET -j NETMAP --to $IN_NET
353         fi
354         ;;
355 down-client:)
356         # connection to my client subnet going down
357         # If you are doing a custom version, firewall commands go here.
358         if [ -n "$PLUTO_MARK_IN" ]
359         then
360             iptables -t mangle -D PREROUTING $SET_MARK_IN
361             iptables -t nat -D PREROUTING -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN \
362                      -d $IN_NET -j NETMAP --to $SAME_NET 
363             iptables -D FORWARD -i $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_IN -j ACCEPT
364             iptables -t nat -D POSTROUTING -o eth1 -m mark --mark $PLUTO_MARK_IN \
365                      -s $SAME_NET -j NETMAP --to $OUT_NET 
366         fi
367         if [ -n "$PLUTO_MARK_OUT" ]
368         then
369             iptables -t mangle -D PREROUTING $SET_MARK_OUT
370             iptables -D FORWARD -o $PLUTO_INTERFACE -m mark --mark $PLUTO_MARK_OUT -j ACCEPT
371         fi
372         ;;
373 *)      echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
374         exit 1
375         ;;
376 esac